<?

$schedule = new JabatoSchedule;

class JabatoSchedule 
{
    var $id = "";
    var $days = array ();
    var $begins = array ();
    var $ends = array ();
    var $recordings = array ();
    var $written = array ();
    var $errorId = -1;
    var $error;
    var $errorDay;
    var $errorBegin;
    var $errorEnd;
    var $daysnames = array ("Todos los D&iacute;as", 
                            "Lunes", 
                            "Martes", 
                            "Mi&eacute;rcoles",
                            "Jueves", 
                            "Viernes", 
                            "S&aacute;bado", 
                            "Domingo",
                            "Ignorar Fila");
    var $f;


    function loadFromJSF () 
    {
        global $JSFFILE;
 
        $xml_parser = xml_parser_create();
        xml_set_element_handler ($xml_parser, 
                                 "loadSchStartElement", 
                                 "loadSchEndElement");

        if ( !($fp = fopen ($JSFFILE, "r"))) 
        {
            die("could not open XML input");
        }

        while ($data = fread ($fp, 4096)) 
        {
            if (!xml_parse ($xml_parser, $data, feof ($fp))) 
            {
                die (sprintf (
                            "XML error: %s at line %d",
                            xml_error_string (xml_get_error_code ($xml_parser)),
                            xml_get_current_line_number ($xml_parser)));
            }
        }
        xml_parser_free($xml_parser);
    }


    function loadFromGlobals () 
    {
        global $blockId;
        global $strips;

        $this->error = "";
        $this->id = $blockId;
        $x = 0;

        for ($i=0; $i < (int)$strips; $i++) 
        {
            global ${"day".$i};
            $day = ${"day".$i};

            if ( (int)$day < 8) 
            {
                $this->days[$x] = $day;
  	
                global ${"begin".$i};
                $aux = explode (":",${"begin".$i});
                $this->begins[$x] = sprintf ("%02d", $aux[0]).":".
                                                       sprintf("%02d", $aux[1]);
                $comienzo = (int)$aux[0].$aux[1]; 
  	    
                global ${"end".$i};
                $aux = explode (":",${"end".$i});
                $this->ends[$x] = sprintf ("%02d", $aux[0]).":".
                                                       sprintf("%02d", $aux[1]);
                $final=(int)$aux[0].$aux[1]; 

                if($comienzo > $final) 
                {
                    $this->error = "ERROR: HORA DE COMIENZO (".$this->begins[$x]
                               .") MAYOR QUE HORA DE FIN (".$this->ends[$x].")";
                }
                elseif ($comienzo > 2400) 
                {
                    $this->error = "ERROR: HORA DE COMIENZO NO VALIDA (".
                                                          $this->begins[$x].")";
                }
                elseif($final > 2400) 
                {
                    $this->error=
                               "ERROR: HORA DE FINALIZACI&Oacute;N NO VALIDA (".
                               $this->ends[$x].")";
                }
	      
                global ${"record".$i};
                $this->recordings[$x] = ${"record".$i};
                $x++;
            }
        }
    }


    function updateJSF ()
    {
        global $JSFFILE;
        global $VARLIBDIR;
  	
        $this->errorId = -1;

        for ($i=0; $i<count($this->days); $i++)
            $this->written[$i] = false;

        if ($this->f = fopen ($JSFFILE.".tmp","w")) 
        {
            $xml_parser = xml_parser_create ();
            xml_set_element_handler ($xml_parser, 
                                     "updateSchStartElement", 
			                         "updateSchEndElement");

            if (!($fp = fopen ($JSFFILE, "r")))
                return false;
 			
            while ($data = fread ($fp, 4096)) 
            {
                if (!xml_parse ($xml_parser, $data, feof($fp)))
                    return false;
            }

            xml_parser_free ($xml_parser);
            fclose ($this->f);

            if ($this->errorId == -1)
            {
                $fecha=date ("Ymd");
                rename ($JSFFILE, "$VARLIBDIR/$fecha.jSF");
                rename ($JSFFILE.".tmp", $JSFFILE);

                error_log (strftime ("%d/%m/%Y\t%H:%M\t", time ()).
                           $this->id."\t".count($this->days)."\n",
 		                   3,
                           $VARLIBDIR."/schedulechanges.log");
                return true;
            }
            else 
            {
                unlink ($JSFFILE.".tmp");
                return false;
            }
        }
        else
            return false;
    }


    function writeStrip ($index) 
    {
        fputs ($this->f,"  <TIMESTRIP BH=\"");
        $aux = explode (":", $this->begins[$index]);
        fputs ($this->f, $aux[0]."\" BM=\"".$aux[1]."\" EH=\"");
        $aux = explode(":", $this->ends[$index]);
		fputs ($this->f, $aux[0]."\" EM=\"".$aux[1]."\" BLOCKID=\"".$this->id.
                                                                         "\" ");
        if (!empty ($this->recordings[$index]))
            fputs ($this->f, "RECORDINGSTRIP=\"1\" ");

        fputs ($this->f, "/>\n");
        $this->written[$index] = true;
    }


    function writeString($str) 
    {
		fputs ($this->f, $str);
    }

  	
    function echoDaySelect ($name, $dayselected)
    {
        echo "<SELECT NAME=\"$name\">\n";

        for ($i=0; $i < count ($this->daysnames); $i++) 
        {
            echo "<OPTION VALUE=$i";

            if($i==$dayselected)
                echo " SELECTED ";

            echo ">".$this->daysnames[$i]."</OPTION>";
        }

        echo "</SELECT>\n";
	}

	
    function echoHTMLForm ()
	{
        global $EDITSCHEDULEPAGE;
        $strips = count ($this->days);

        echo "<form action=$EDITSCHEDULEPAGE method=POST>";
        echo "<table cellspacing=4>";

        for($i=0; $i < $strips; $i++) 
        {
            echo "<tr><td>";
            $this->echoDaySelect("day".$i, $this->days[$i]);
            echo "<td align=center>DE&nbsp;&nbsp;&nbsp;&nbsp;";
            echo "<input name=begin".$i." value=".$this->begins[$i]." size=6>";
            echo "<td align=center> A&nbsp;&nbsp;";
            echo "<input name=end".$i." value=".$this->ends[$i]." size=6>";
            echo "<td align=center>&nbsp;&nbsp;";
            echo "<input type=\"checkbox\" name=\"record".$i."\" ";

            if (!empty ($this->recordings[$i]))
                echo "checked ";

            echo "/> Emisi&oacute;n en directo";
            echo "</tr>";
        }

        echo "<tr><td>";

        if ($this->errorId == -1) 
        {
            $this->echoDaySelect ("day".$strips, 8);
            echo "<td align=center>DE&nbsp;&nbsp;&nbsp;&nbsp;";
            echo "<input name=begin".$strips." value=\"\" size=6>";
            echo "<td align=center> A&nbsp;&nbsp;";
            echo "<input name=end".$strips." value=\"\" size=6>";
            echo "<td align=center>&nbsp;&nbsp;";
            echo "<input type=\"checkbox\" name=\"record".$strips.
                                              "\" /> Emisi&oacute;n en directo";
            echo "</tr>";
            echo "<input type=hidden name=strips value=".($strips+1)." >";
        }
        else
            echo "<input type=hidden name=strips value=".($strips)." >";

        echo "</table>";
        echo "<input type=hidden name=blockId value=$this->id >";
        echo "<input type=submit value=\"Modificar parrilla\">";

        echo "</form>";
    }

}


$currentDay = -1;


function loadSchStartElement ($parser, $name, $attrs) 
{
    global $schedule;
    global $currentDay;

    if ($name == "DAY")
        $currentDay = (int)$attrs["DAYOFWEEK"];

    else if ($name == "TIMESTRIP") 
    {
        if ($attrs["BLOCKID"] == $schedule->id) 
        {
            $ind = count($schedule->days);
            $schedule->days[$ind] = $currentDay;
            $schedule->begins[$ind] = sprintf ("%02d", $attrs["BH"]).":".
                                                 sprintf ("%02d", $attrs["BM"]);
            $schedule->ends[$ind] = sprintf ("%02d", $attrs["EH"]).":".
                                                 sprintf ("%02d", $attrs["EM"]);
            $schedule->recordings[$ind] = $attrs["RECORDINGSTRIP"];
        }
    }
}


function loadSchEndElement ($parser, $name) { }


$lastId;
$lastBegins;
$lastEnds;


function updateSchStartElement ($parser, $name, $attrs) 
{
    global $schedule;
    global $currentDay;	
	
    if ($schedule->errorId == -1) 
    {
        if ($name=="TIMESTRIP") 
        {
            $id = $attrs["BLOCKID"];

            if ($id != $schedule->id) 
            {
                $begin = sprintf ("%02d", $attrs["BH"]).":".sprintf (
                                                                  "%02d", 
                                                                  $attrs["BM"]);
                $end = sprintf ("%02d",$attrs["EH"]).":".sprintf ("%02d",
                                                                  $attrs["EM"]);
                $i = 0;
                while (($i < count ($schedule->days)) && 
                       ($schedule->errorId == -1))
                {
                    if (($schedule->days[$i] == $currentDay) &&
                        (!$schedule->written[$i])) 
                    {
                        if ($schedule->ends[$i] <= $begin)
                            $schedule->writeStrip($i);

                        else if ($schedule->begins[$i] < $end)
                            $schedule->errorId = $id;
                    }
                    $i++;
				}

                if ($schedule->errorId != -1) 
                {
                    $schedule->errorDay = $currentDay;
                    $schedule->errorBegin = $begin;
                    $schedule->errorEnd = $end;
                }
                else 
                {
                    $schedule->writeString ("  <".$name." ");

                    for (reset ($attrs); $ind = key ($attrs); next ($attrs))
                        $schedule->writeString ($ind."=\"".$attrs[$ind]."\" ");

                    $schedule->writeString("/>\n");
                }
            }
        }
		else 
        {
            $schedule->writeString ("<".$name." ");

            for (reset ($attrs); $ind=key ($attrs); next ($attrs))
                $schedule->writeString ($ind."=\"".$attrs[$ind]."\" ");

            if ($name == "EXECAT")
                $schedule->writeString ("/>\n");
            else
                $schedule->writeString (">\n");

            if ($name == "DAY")
                $currentDay = (int)$attrs["DAYOFWEEK"];
		}
	}
}


function updateSchEndElement ($parser, $name) 
{
    global $schedule;
    global $currentDay;	

    if (($name == "JABATOSCHEDULEFILE") ||
	    ($name == "DAY")) 
    {
        if (($name == "DAY") && ($schedule->errorId == -1)) 
        {
            $i = 0;
            while ($i<count ($schedule->days)) 
            {
                if (($schedule->days[$i] == $currentDay) &&
                    (!$schedule->written[$i])) 
                {
                    $schedule->writeStrip($i);
                    if ($currentDay!=0) 
                        break; //DANGEROUS REMOVAL;
                }
                $i++;
            }
        }

        $schedule->writeString ("</".$name.">\n");
	}
}

?>

