#!/bin/bash

webdir=$1
datadir=$2
bindir=$3
radio_station=$4
jabatofile=`$webdir/scripts/get_jabato_file.sh`
scheduletitle=`$webdir/scripts/get_schedule_title.sh $radio_station`
bodyargs="background='img/bg.png'"

cp --preserve=mode $datadir/jsf.xml $datadir/$jabatofile.jSF;
cp --preserve=mode $datadir/jbf.xml $datadir/$jabatofile.jBF;

# -----------------------------------------------------------------
# GENERACION DE PARRILLA
# -----------------------------------------------------------------
# NOMBRES DE PROGRAMAS CON ENLACES A SUS PAGINAS
$bindir/parrillaJabata -o=programslinks \
              -php \
              -linkscolor="#919191" \
		> $datadir/php/enlaces.html
		
# PARRILLA PROPIAMENTE
$bindir/parrillaJabata -o=schedule \
		-php \
                -beginat=0 \
                -title="$scheduletitle" \
                -withoutbody \
		> $datadir/php/parrilla_contents.php

		
# PARRILLA PARA IMPRIMIR
$bindir/parrillaJabata -o=sch4printer \
                -php \
                -hidecontinuity \
                -beginat=0 \
                -title="$scheduletitle" \
    > $datadir/php/parrilla4printer.html

# PAGINAS DE LOS PROGRAMAS
for i in $($bindir/parrillaJabata -o=rawids)
do
  $bindir/parrillaJabata -o=$i \
		-php \
      	-bodyargs="$bodyargs" \
    > $datadir/php/$i.php;
done
